/* 1) Make sure your mouse buttons are the default in Windows and/or whatever mouse software you use - specifically Mouse3 (middle button) and Mouse4 (thumb/side button)
 * 2) I have Win7 x64 so not sure if this will act/work for people who have older OS or 32 bit versions of Win 7
 * 3) All control binds in Skyrim should be reset to default with the exception of "Sneak" which I rebound to 'u' inside of the game.
 * 4) These SHOULD work with NumLock on or off but there might be bugs. If so, please edit accordingly and post in the thread. Thanks.
 * 
 * The controls are as follows:
 * Move Forward (anything using 'W'): Num8
 * Move Backward (anything using 'S): Num5
 * Strafe Left (anything using 'A'): Num4
 * Strafe Right (anything using 'D): Num6
 * 
 * Jump : Num0
 * Sprint : Num. (also known as NumDel)
 * Sneak : Mouse4 + Num.
 * 
 * Hotkey1 : Num7
 * Hotkey2 : Num9
 * Hotkey3 : Num1
 * Hotkey4 : Num3
 * Hotkey5 : Mouse4 + Num7
 * Hotkey6 : Mouse4 + Num9
 * Hotkey7 : Mouse4 + Num1
 * Hotkey8 : Mouse4 + Num3
 * 
 * Shout : Num2
 * 
 * Interact (Anything using 'E' key) : Mouse3
 * Sheathe & Unsheathe / Take All (Anything using 'R' key) : Num+
 * Favorites Menu (Anything using 'Q' key) : NumEnter
 * Menu / Escape Menu (Anything using 'Tab' key) : Num*
 * Inventory (Anything using 'I' key) : Num/
 * 
 * Numpad- is unbound since I don't use it.
 * 
 * These keys within Skyrim are unchanged:
 * p for spells
 * f for camera or making something a favorite
 * j for journal
 * t for wait
 * m for map
 * / for stats
 * y for yes
 * n for no
 * 
 * ************************************************** *************
 * ***** COPY AND PASTE THE FOLLOWING SCRIPT INTO AUTOHOTKEY *****
 * ************************************************** *************
 */

; Assumes MiddleMouse (Mouse3) and ThumbMouse (Mouse4) are set to default in OS/Mouse Software
; all keys are default in Skyrim except for sneak which I've rebound to 'u' from within the game

;Movement
Numpad8::w
NumpadUp::w
Numpad4::a
NumpadLeft::a
Numpad5::s
NumpadClear::s
Numpad6::d
NumpadRight::d

;Jump
Numpad0::space
NumpadIns::space

;Sprint
NumpadDot::Alt
NumpadDel::Alt

;Stealth (uses Ctrl modifier)
XButton1 & NumpadDot::Send {u}
XButton1 & NumpadDel::Send {u}

;Take, Interact
MButton::e

;1-8 hotkeys. 5-8 use MouseButton4 as a Modifier
Numpad7::1
NumpadHome::1
Numpad9::2
NumpadPgUp::2
Numpad1::3
NumpadEnd::3
Numpad3::4
NumpadPgDn::4
XButton1 & Numpad7::Send {5}
XButton1 & NumpadHome::Send {5}
XButton1 & Numpad9::Send {6}
XButton1 & NumpadPgUp::Send {6}
XButton1 & Numpad1::Send {7}
XButton1 & NumpadEnd::Send {7}
XButton1 & Numpad3::Send {8}
XButton1 & NumpadPgDn::Send {8}

;Shout
Numpad2::z
NumpadDown::z

;Favorites Menu
NumpadEnter::q

;Menu, Escape Menu
NumpadMult::Tab

;Ready & Sheathe Weapon, Take All
NumpadAdd::r

;Inventory
NumpadDiv::i

;Unused Numpad Keys
NumpadSub::

;Unchanged Skyrim Shortcuts
;p => spells
;f => camera, make favorite
;j => journal
;t => wait
;m => map
;/ => stats 