ClonesPush(strKeys)
{
	global WowWinId1
	global WowWinId2
	IfWinNotActive, ahk_id %WowWinId1%
		ControlSend, , %strKeys%, ahk_id %WowWinId1%
	IfWinNotActive, ahk_id %WowWinId2%
		ControlSend, , %strKeys%, ahk_id %WowWinId2%
}

;Grab unique window ID's
WinGet, WowWinId, List, World of Warcraft

; *******************************
; *** Only if WoW is in focus ***
; *******************************
#IfWinActive, World of Warcraft

;*** Special Functions ***

; *** Makes clones follow main ***
-::ClonesPush("{- down}{- up}")

; *** Makes clones assist main ***
=::ClonesPush("{= down}{= up}")

; *** Move clones ***
Up::ClonesPush("{Up down}")
Up Up::ClonesPush("{Up up}")
Down::ClonesPush("{Down down}")
Down Up::ClonesPush("{Down up}")
Left::ClonesPush("{Left down}")
Left Up::ClonesPush("{Left up}")
Right::ClonesPush("{Right down}")
Right Up::ClonesPush("{Right up}")

; ******************
; *** Extra Stuff ***
; ******************

; *** Makes clone Loot ***
~;::ClonesPush("{; down}{; up}")

; *** Makes clones jump with main ***
~Space::ClonesPush("{Space down}{Space up}")

; *** Suspends HotKeys while typing on main ***
~Enter::Suspend, Toggle
~/::Suspend, On
~Escape::Suspend, Off
~PgDn::Suspend, Toggle

; *******************
; *** Hotbars 1-0 ***
; *******************
~1::ClonesPush("{= down}{= up}{1 down}{1 up}")
~2::ClonesPush("{= down}{= up}{2 down}{2 up}")
~3::ClonesPush("{= down}{= up}{3 down}{3 up}")
~4::ClonesPush("{= down}{= up}{4 down}{4 up}")
~5::ClonesPush("{= down}{= up}{5 down}{5 up}")
~6::ClonesPush("{= down}{= up}{6 down}{6 up}")
~7::ClonesPush("{= down}{= up}{7 down}{7 up}")
~8::ClonesPush("{= down}{= up}{8 down}{8 up}")
~9::ClonesPush("{= down}{= up}{9 down}{9 up}")
~0::ClonesPush("{= down}{= up}{0 down}{0 up}")

; ***************************
; *** Hotbars SHIFT(+) 1-0 ***
; ***************************
~+1::ClonesPush("{LShift down}{1 down}{1 up}{LShift up}")
~+2::ClonesPush("{LShift down}{2 down}{2 up}{LShift up}")
~+3::ClonesPush("{LShift down}{3 down}{3 up}{LShift up}")
~+4::ClonesPush("{LShift down}{4 down}{4 up}{LShift up}")
~+5::ClonesPush("{LShift down}{5 down}{5 up}{LShift up}")
~+6::ClonesPush("{LShift down}{6 down}{6 up}{LShift up}")
~+7::ClonesPush("{LShift down}{7 down}{7 up}{LShift up}")
~+8::ClonesPush("{LShift down}{8 down}{8 up}{LShift up}")
~+9::ClonesPush("{LShift down}{9 down}{9 up}{LShift up}")
~+0::ClonesPush("{LShift down}{0 down}{0 up}{LShift up}")

; **************************
; *** Hotbars CTRL(^) 1-0 ***
; **************************
~^1::ClonesPush("{Ctrl down}{1 down}{1 up}{Ctrl up}")
~^2::ClonesPush("{Ctrl down}{2 down}{2 up}{Ctrl up}")
~^3::ClonesPush("{Ctrl down}{3 down}{3 up}{Ctrl up}")
~^4::ClonesPush("{Ctrl down}{4 down}{4 up}{Ctrl up}")
~^5::ClonesPush("{Ctrl down}{5 down}{5 up}{Ctrl up}")
~^6::ClonesPush("{Ctrl down}{6 down}{6 up}{Ctrl up}")
~^7::ClonesPush("{Ctrl down}{7 down}{7 up}{Ctrl up}")
~^8::ClonesPush("{Ctrl down}{8 down}{8 up}{Ctrl up}")
~^9::ClonesPush("{Ctrl down}{9 down}{9 up}{Ctrl up}")
~^0::ClonesPush("{Ctrl down}{0 down}{0 up}{Ctrl up}")

; *********************
; *** Hotbars F1-F12 ***
; *********************
~F1::ClonesPush("{= down}{= up}{F1 down}{F1 up}")
~F2::ClonesPush("{= down}{= up}{F2 down}{F2 up}")
~F3::ClonesPush("{= down}{= up}{F3 down}{F3 up}")
~F4::ClonesPush("{= down}{= up}{F4 down}{F4 up}")
~F5::ClonesPush("{= down}{= up}{F5 down}{F5 up}")
~F6::ClonesPush("{= down}{= up}{F6 down}{F6 up}")
~F7::ClonesPush("{= down}{= up}{F7 down}{F7 up}")
~F8::ClonesPush("{= down}{= up}{F8 down}{F8 up}")
~F9::ClonesPush("{= down}{= up}{F9 down}{F9 up}")
~F10::ClonesPush("{= down}{= up}{F10 down}{F10 up}")
~F11::ClonesPush("{= down}{= up}{F11 down}{F11 up}")
~F12::ClonesPush("{= down}{= up}{F12 down}{F12 up}")

; ***************************
; *** Hotbars SHIFT F1-F12 ***
; ***************************
~+F1::ClonesPush("{LShift down}{F1 down}{F1 up}{LShift up}")
~+F2::ClonesPush("{LShift down}{F2 down}{F2 up}{LShift up}")
~+F3::ClonesPush("{LShift down}{F3 down}{F3 up}{LShift up}")
~+F4::ClonesPush("{LShift down}{F4 down}{F4 up}{LShift up}")
~+F5::ClonesPush("{LShift down}{F5 down}{F5 up}{LShift up}")
~+F6::ClonesPush("{LShift down}{F6 down}{F6 up}{LShift up}")
~+F7::ClonesPush("{LShift down}{F7 down}{F7 up}{LShift up}")
~+F8::ClonesPush("{LShift down}{F8 down}{F8 up}{LShift up}")
~+F9::ClonesPush("{LShift down}{F9 down}{F9 up}{LShift up}")
~+F10::ClonesPush("{LShift down}{F10 down}{F10 up}{LShift up}")
~+F11::ClonesPush("{LShift down}{F11 down}{F11 up}{LShift up}")
~+F12::ClonesPush("{LShift down}{F12 down}{F12 up}{LShift up}")
